<!--
 * @Author: zhp
 * @Date: 2023-01-11 09:24:58
 * @LastEditTime: 2023-06-29 13:57:15
 * @LastEditors: zwq
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <!-- <el-badge :value="1" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge> -->
      </SearchBar>
      <base-table :table-props="tableProps" :page="listQuery.page" :limit="listQuery.limit" :table-data="tableData">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="110" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog
        :dialogTitle="addOrEditTitle"
        :dialogVisible="addOrUpdateVisible"
        @cancel="handleCancel"
        @confirm="handleConfirm"
        :before-close="handleCancel"
      >
        <add-or-update ref="addOrUpdate" @refreshDataList="successSubmit"></add-or-update>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page"
// import InspectionPositionAdd from "./components/InspectionPosition-add"
import AddOrUpdate from './components/startEightDisciplinePreliminaryAnalysis-add.vue'
// import failureTypeSearch from "./components/failureTypeSearch"
// import available from "./components/available.vue"
import basicSearch from "@/mixins/basic-search"
import i18n from "@/i18n"
import codeFilter from '@/filters/code-filter'
import { timeFormatter } from "@/filters/code-filter"
const tableProps = [
  {
    prop: 'title',
    label: i18n.t("code.title"),
    align: 'center'
  },
  {
    prop: 'code',
    label: i18n.t("code.code"),
    align: 'center'
  },
  {
    prop: 'eightDisciplineType',
    label: i18n.t("code.eightDisciplineType"),
    align: 'center',
    filter: codeFilter('eightDisciplineType'),
  },
  {
    prop: 'occurrenceDate',
    label: i18n.t("code.occurrenceDate"),
    align: 'center',
    filter: timeFormatter,
  },
  // {
  //   prop: 'productName',
  //   label: i18n.t("code.productName"),
  //   align: 'center'
  // },
  // {
  //   prop: 'customName',
  //   label: i18n.t("code.customName"),
  //   align: 'center'
  // },
  {
    prop: 'description',
    label: i18n.t("code.description"),
    align: 'center'
  },
  {
    prop: 'userId',
    label: i18n.t("code.userId"),
    align: 'center'
  }
]
const tableBtn = [
  // {
  //   type: "edit",
  //   btnName: "编辑",
  // },
  {
    type: "delete",
    btnName: "删除",
  },
  {
    type: "analysis",
    btnName: "分析",
  },
];
export default {
  mixins: [basicPage, basicSearch],
  components: {
    AddOrUpdate,
  },
  data() {
    return {
      urlOptions: {
        getDataListURL: "/code/startEightDiscipline/page",
        deleteURL: "/code/startEightDiscipline",
      },
      tableProps,
      tableBtn,
      searchOrEditTitle: '',
      listQuery: {
        limit: 10,
        page: 1,
        eightDisciplineStatus:1,
        examineStatus: 0
      },
      searchOrUpdateVisible: false,
      formConfig: [
        {
          type: 'input',
          label: i18n.t('code.title'),
          placeholder: i18n.t('code.title'),
          param: 'title'
        },
        // {
        //   type: "",
        //   label: i18n.t("params.paramCode"),
        //   placeholder: i18n.t("params.paramCode"),
        //   param: "paramCode",
        // },
        // {
        //   type: "separate",
        // },
        {
          type: "button",
          btnName: "搜索",
          name: "search",
          color: "primary",
        }
      ],
    };
  },
  // components: {
  //   AddOrUpdate,
  // },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    conditionSearchSubmit(dataForm) {
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      console.log(val);
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.failureTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrUpdateVisible = true
        this.addOrEditTitle = this.$t('edit')
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data.id);
        });
      } else if (val.type === "analysis") {
        this.addOrUpdateVisible = true
        this.addOrEditTitle = "初步分析"
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data);
        });
      }
    },
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.page = 1;
          this.listQuery.title = val.title ? val.title : ''
          this.listQuery.failureTypeStatus = null
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = this.$t('add')
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        default:
          console.log(val)
      }
    },
  }
};
</script>
